#!/bin/bash

ulimit -c unlimited

DIR=$(pwd)
nginx_fname=$(ls -1 $DIR/install/*.tar.gz)

[ -d install/tmp ] || mkdir install/tmp
tar zxf $nginx_fname -C install/tmp

folder="$(ls -1 $DIR/install/tmp | grep nginx)"

export PATH=$DIR/install/tmp/$folder/sbin:$PATH
export LD_LIBRARY_PATH=$DIR/install/tmp/$folder/lib
export LUA_CPATH="$DIR/install/tmp/$folder/lib/lua/5.1/?.so"

ret=0

#export TEST_NGINX_USE_VALGRIND=1

for t in $(ls t/*.t)
do
  echo "Tests : "$t
  if [[ $t =~ "hup" ]]; then
    export TEST_NGINX_USE_HUP=1
  else
    export TEST_NGINX_USE_HUP=0
  fi
  prove $t
  if [ $? -ne 0 ]; then
    ret=$?
  fi
done

rm -rf t/servroot
rm -rf install/tmp

exit $ret